class Term {
    String name;
    boolean isVariable;

    Term(String name, boolean isVariable) {
        this.name = name;
        this.isVariable = isVariable;
    }

    @Override
    public String toString() {
        return name;
    }
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
        if (obj == null || getClass() != obj.getClass()) return false;
        Term other = (Term) obj; 
		return this.name.equals(other.name) && this.isVariable == other.isVariable;
	} 
}